# Lab 2


## Диаграмма классов:

```mermaid
classDiagram
    class BinarySearchTree {
        - root : Node
        + add(student : Student) : void
        + each(&block) : void
        - insert(node : Node, student : Student) : Node
        - in_order_traversal(node : Node, &block) : void
    }

    class Node {
        - student : Student
        - left : Node
        - right : Node
        + Node(student : Student)
    }

    class Contact {
        - phone : String?
        - telegram : String?
        - email : String?
        + Contact(phone : String?, telegram : String?, email : String?)
        + present() : Boolean
        + get_single_contact() : String
        + phone=(String) : Boolean
        + telegram=(String) : Boolean
        + email=(String) : Boolean
        + self.valid_phone_number() : Boolean
        + self.valid_telegram() : Boolean
        + self.valid_email() : Boolean
        + new_from_info(info_string : String) : Contact
    }

    class Person {
        - id : String
        - git : String
        - contact : Contact
        + Person(id : String, git : String, contact : Contact = new Contact())
        + git_present() : Boolean
        + contact_present() : Boolean
        + contact_info() : String
        + git=(git : String) : void
        - validate_id(id: String) : void
        - validate_git(git : String) : void
        - validate_contact(contact : Contact) : void
        - valid_git?(git : String) : Boolean
        - valid_id?(id : String) : Boolean
    }

    class StudentRepository {
        + self.read_from_txt(file_path : String) : List~Student~
        + self.write_to_txt(file_path : String, students : List~Student~)
    }

    class StudentShort {
        - surname_initials : String
        + StudentShort(id : String, git : String, surname_initials : String, contact : Contact)
        + self.from_student(student : Student) : StudentShort
        + self.from_string(id : String, info_string : String) : StudentShort
        + to_s() : String
    }

    class Student {
        - surname : String
        - name : String
        - patronymic : String
        - birth_date : Date
        - const NAME_REGEX : String
        + Student(id : String, git : String, contact : Contact, surname : String, name : String, patronymic : String, birth_date : Date)
        + self.from_string(student_string : String) : Student
        + surname_and_initials() : String
        + to_s() : String
        + get_info() : String
        + surname=(surname : String)
        + name=(name : String)
        + patronymic=(patronymic : String)
        + birth_date=(birthdate : String)
        + self.valid_name?(name : String) : Boolean
        - name_initial(name : String) : String
        - patronymic(patronymic : String) : String
    }

    BinarySearchTree o-- Node
    Node o-- Student
    Contact <|-- Person
    Person <|-- Student
    Person <|-- StudentShort
    Student <.. StudentRepository
```

